\documentclass{article}

\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{subcaption}
\usepackage{tikz}
\usetikzlibrary{calc,positioning}

\newcommand{\dxdy}[2]{\frac{d #1}{d #2}}
\newcommand{\dxdyk}[3]{\frac{d^{#3} #1}{d {#2}^{#3}}}
\newcommand{\pdxdy}[2]{\frac{\partial #1}{\partial #2}}
\newcommand{\liminfty}[1]{\lim_{#1 \to \infty}}
\newcommand{\limab}[2]{\lim_{#1 \to #2}}

\newcommand{\abs}[1]{\left \vert #1 \right \vert}
\newcommand{\norm}[1]{\left \Vert #1 \right \Vert}
\newcommand{\order}[1]{\mathcal{O} \left ( #1 \right )}
\newcommand{\set}[1]{\left \{ #1 \right \}}
\newcommand{\Set}[2]{\left \{ #1 \ \middle \vert \ #2 \right \}}
\newcommand{\vmat}[1]{\begin{vmatrix} #1 \end{vmatrix}}
\DeclareMathOperator{\sign}{sign}
\DeclareMathOperator{\Span}{span}

\newcommand{\bbn}{\mathbb{N}}
\newcommand{\bbz}{\mathbb{Z}}
\newcommand{\bbq}{\mathbb{Q}}
\newcommand{\bbr}{\mathbb{R}}
\newcommand{\bbc}{\mathbb{C}}
\newcommand{\bbf}{\mathbb{F}}

\newtheorem{lemma}{Lemma}
\newtheorem{thm}{Theorem}
\newtheorem{cor}{Corollary}
\newtheorem{prop}{Proposition}
\newtheorem{conj}{Conjecture}
\newtheorem{defn}{Definition}
\newtheorem{example}{Example}

\let\vec\mathbf

\begin{document}

\section{Meeting notes}

\subsection{}

Nonlinear preconditioning: Krylov as extrapolation methods.
There exists proof of quadratic convergence (Sidi, \textit{Extrapolation vs. projection methods for linear systems of equations}, copy here)

Method of Richardson:
\begin{equation*}
	u^{k+1} = u^k + \frac{1}{\alpha_k} (f-Au^k)
\end{equation*}
where $\alpha_k$ is a parameter of the acceleration.
This leads to a formula for the errors (?)
\begin{equation*}
	e_k^{n+1} = \dots = \Pi_{j=0}^n \left ( 1 - \frac{\lambda_k}{\alpha_j} \right ) e_k^0.
\end{equation*}
Choose $\alpha_j$ to minimize the polynomial.
This leads to Chebyshev polynomials.

Need to know spectrum.
Alternative: take linear combinations of previous iterates.
\begin{align*}
e^n = & u - u^n \\
\sum \gamma_j u^j = & u \sum \gamma_j + \sum \gamma_j e^j \\
v^n = & u + \sum \gamma_j e^j \\
u - v^n = \sum \gamma_j e^j
\end{align*}
and the goal is to minimize the last line.
Set $d^n = u^{n+1} - u^n$ and
\begin{align*}
u = & M^{-1} N u + M^{-1} f \\
u^{n+1} = & M^{-1} N u^{n-1} + M^{-1} f \\
e^{n+1} = & u - u^{n+1} = M^{-1} N e^n \\
\implies \sum \gamma_j e^j = & \sum \gamma_j G^j e^0 = p_n(G) e^0 \\
d^n = & G d^{n-1} = G^n d^0 \\
\sum \gamma_j d^j = & \sum \gamma_j G^j d^0 = p_n(G) d^0.
\end{align*}
Minimizing this last equation is called Modified Polynomial Extrapolation.
(nb: no it's not, it's called Minimized Polynomial Extrapolation)

Overdetermine the system:
\begin{equation*}
\sum \tilde{\gamma}_j d^j = -d^n
\end{equation*}
which leads to Krylov (thm, where? copy).

Try to get to different method from Newton.
Which methods have quadratic convergence?
Apply methods to altS example.

References to look into:
\begin{itemize}
\item book with Walter and Felix
\item Brezinski (book)
\item Sidi, sequence of papers
\end{itemize}

Questions:
\begin{itemize}
\item what characterizes a quadratic acceleration method?
\item what is the general framework of acceleration methods?
\item do the sequences of Schwarz methods have distinct forms? Can they be predicted/exploited?
\end{itemize}

\subsection{Meeting 14.07.2021}

Goal is to take Newton's method and connect it to an extrapolation method and then a Krylov method, in an attempt to unify these types of nonlinear solves.
Also to apply extrapolation methods to the sinusoid altS example to see how they deal with these problems.
(Extrapolation methods are unlikely to find fault with this example as they will only accelerate a monotonically converging sequence; only a method seeking to quadratically converge would dramatically change the convergence behaviour.)

To read:
\begin{itemize}
\item Brezinski, Numerical stability of a quadratic method for solving systems of nonlinear equations
\item Shafer, On quadratic approximation
\item Brezinski, Méthodes d'acceleartion de la convergence en analyse numerique
\item Gekeler, On the solution of systems of equations by the epsilon algorithm of Wynn
\end{itemize}

\section{Framework of acceleration methods}

Take a sequence $(S_n) \to S$.
Let $T$ be a transformation such that $T(S_n) = T_n$.
The transformation $T$ is an acceleration if $(T_n) \to S$ faster than $(S_n)$, ie.
\begin{equation}
\lim_{n \to \infty} \frac{T_n - S}{S_n - S} = 0.
\end{equation}
The kernel of a transformation $T$ is the set of sequences such that $T_n = S$ for all $n \in \bbn$.

\begin{example}
\begin{equation}
T_n = \frac{S_n S_{n+2} - S_{n+1}^2}{S_{n+2} - 2 S_{n+1} + S_n}
\end{equation}
then
\begin{align*}
\liminfty{n} \frac{T_n - S}{S_n - S} = & \liminfty{n} \frac{S_n S_{n+2} - S_{n+1}^2 - S (S_{n+2} - 2S_{n+1} + S_n)}{S_{n+2} - 2S_{n+1} + S_n} \frac{1}{S_n - S} \\
= & \liminfty{n} \frac{S_{n+2} (S_n - S) - S_{n+1} (S_{n+1} - S) - S (S_n - S_{n+1})}{(S_n-S) (S_{n+2} - 2 S_{n+1} + S_n)} \\
= & \liminfty{n} \frac{S_{n+2} - \frac{S_{n+1} - S}{S_n - S} S_{n+1} - \frac{S_n - S + S - S_{n+1}}{S_n - S} S}{S_{n+2} - 2 S_{n+1} + S_n} \\
= & \liminfty{n} \frac{S_{n+2} - S - \frac{S_{n+1} - S}{S_n - S} (S_{n+1} - S)}{S_{n+2} - 2 S_{n+1} + S_n} .
\end{align*}
If $\lim (S_{n+1} - S)/(S_n - S) \in [-1,1)$ then the sequence is accelerated (missing a step?).

The kernel of this transformation is $S_n = S + a \lambda^n$ for $\lambda \neq 1$ and $a \neq 0$:
\begin{align*}
T_n = & \frac{(S + a \lambda^n)(S + a \lambda^{n+2}) - (S + a \lambda^{n+1})^2}{S + a \lambda^{n+2} - 2S - 2 a \lambda^{n+1} + S + a \lambda^n} \\
= & \frac{S^2 + a \lambda^n S + a \lambda^{n+2} S + a^2 \lambda^{2n + 2} - S^2 - 2 a \lambda^{n+1} S - a^2 \lambda^{2n + 2}}{a \lambda^n (\lambda^2 - 2 \lambda + 1)} \\
= & \frac{a \lambda^n S ( 1 + \lambda^2 - 2 \lambda)}{a \lambda^n (\lambda - 1)^2} = S .
\end{align*}
\end{example}

\newcommand{\kernel}{\mathcal{K}_T}

A transformation may be expressed as a relation on $q$ elements of a sequence, $R(S_n,S_{n+1}, \dots, S_{n+q}, S)$.
In this form, if $(S_n) \in \kernel$, the kernel of the transformation, then $R(S_n, \dots, S_{n+q}, S) = 0$ for all $n \in \bbn$.

\begin{defn}[Extrapolation method]
A transformation $T$ is an extrapolationmethod if
\begin{equation}
T_n = S \ \forall n \in \bbn \iff (S_n) \in \kernel.
\end{equation}
\end{defn}

(Somehow this already defines the kernel of the transformation; is this definition then vacuous?
It is stated in Brezinski that because of this definition any sequence transformation can be viewed as an extrapolation method.)

For some methods this relation may be expressed as
\begin{equation}
R(S_n, \dots, S_{n+q}, S) =0 \iff S = T_n = \sum_{i=0}^q a_i S_{n+i}.
\end{equation}

\begin{example}
Suppose $R(S_n,S_{n+1},S) = a_1 (S_n - S) + a_2 (S_{n+1} - S) = 0$ for all $n$.
Then
\begin{align*}
a_1 & (S_n-S) && + & a_2 (S_{n+1} - S) = & 0 \\
a_1 & (S_{n+1} - S) && + & a_2 (S_{n+2} - S) = & 0.
\end{align*}
WLOG (can you prove it?) $a_1 + a_2 = 1$ and
\begin{align*}
S = & a_1 S_n + (1-a_1) S_{n+1} \\
S = & a_1 S_{n+1} + (1 - a_1) S_{n+2} \\
\implies 0 = & a_1 \Delta S_n + (1 - a_1) \Delta S_{n+1}
\end{align*}
where $\Delta S_n = S_{n+1} - S_n$.
And so $a_1 = \Delta S_{n+1} / \Delta^2 S_n$.
This leads to the transformation described in the previous example,
\begin{equation}
T_n = \frac{S_n S_{n+2} - S_{n+1}^2}{S_{n+2} - 2 S_{n+1} + S_n}.
\end{equation}

Note that $dR/dS = -(a_1 + a_2)$.
\end{example}

\section{E-algorithm and derivatives}

For the E-algorithm it is assumed that the relation $R$ has the form
\begin{equation}
S_n - S - \sum_{i=1}^k a_i g_i(n) = 0
\end{equation}
where $g_i(n)$ are some functions that depend on the indices $i$ and $n$ and the elements $\set{S_{n+j}}_{j=0}^k$.
By solving the system created by repeating this equation for $n$ to $n+k$ in the same manner as the previous example one arrives at the solution
\begin{equation}
S = T_k^{(n)} = \frac{\vmat{S_n & \dots & S_{n+k} \\ g_1(n) & \dots & g_1(n+k) \\ \vdots & & \vdots \\ g_k(n) & \dots & g_k(n+k)}}{\vmat{1 & \dots & 1 \\ g_1(n) & \dots & g_1(n+k) \\ \vdots & & \vdots \\ g_k(n) & \dots & g_k(n+k)}} .
\end{equation}
The kernel of this transformation is
\begin{equation}
S_n = S + \sum_{i=1}^k a_i g_i(n)
\end{equation}
which may be readily obtained by rearranging the relation $R$.

\section{Summary of Sidi proof of MPE=Arnoldi}

Let $(x_n)$ be a vector sequence to be accelerated, then we produce approximations
\begin{equation}
T_n^{(k)} = \sum_{j=0}^k \gamma_j^{(n,k)} x_{n+j}
\end{equation}
where
\begin{equation*}
\sum_{j=0}^k \gamma_j^{(n,k)} = 1 .
\end{equation*}
The $\gamma_j^{(n,k)}$ also satisfy
\begin{equation} \label{eq:gamma 2}
\sum_{j=0}^k \langle \Delta x_{n+i}, \Delta x_{n+j} \rangle \gamma_j^{(n,k)} = 0, \quad 0 \leq i \leq k-1
\end{equation}
where $\langle \cdot, \cdot \rangle$ is the L2 inner product.
The $\Delta$ operator has been defined previously but we reiterate it here:
\begin{equation*}
\Delta x_{n+i} = x_{n+i+1} - x_{n+i}.
\end{equation*}
We've seen previously that $T_n^{(k)}$ can be written as
\begin{equation*}
T_n^{(k)} = \frac{ \vmat{ x_n & \dots & x_{n+k} \\ \langle \Delta x_n, \Delta x_n \rangle & \dots & \langle \Delta x_n, \Delta x_{n+k} \rangle \\ \vdots & & \vdots \\ \langle \Delta x_{n+k-1}, \Delta x_n \rangle & \dots & \langle \Delta x_{n+k-1}, \Delta x_{n+k} \rangle }}{ \vmat{ 1 & \dots & 1 \\ \langle \Delta x_n, \Delta x_n \rangle & \dots & \langle \Delta x_n, \Delta x_{n+k} \rangle \\ \vdots & & \vdots \\ \langle \Delta x_{n+k-1}, \Delta x_n \rangle & \dots & \langle \Delta x_{n+k-1}, \Delta x_{n+k} \rangle}} .
\end{equation*}
The notion of the determinant is generalized here to allow for a vector result.
That is, we expand along the first row so that each $x_{n+i}$ is multiplied by the determinant of a submatrix.
That means each $\gamma_j^{(n,k)}$ is equal to
\begin{equation}
\gamma_j^{(n,k)} = \frac{\vmat{\langle \Delta x_n, \Delta x_n \rangle & \dots & \langle \Delta x_n, \Delta x_{n+j-1} \rangle & \langle \Delta x_n, \Delta x_{n+j+1} \rangle & \dots & \langle \Delta x_n, \Delta x_{n+k} \rangle \\
				 \vdots & & \vdots & \vdots & & \vdots \\ 
				 \langle \Delta x_{n+k-1}, \Delta x_n \rangle & \dots & \langle \Delta x_{n+k-1}, \Delta x_{n+j-1} \rangle & \langle \Delta x_{n+k-1}, \Delta x_{n+j+1} \rangle & \dots & \langle \Delta x_{n+k-1}, \Delta x_{n+k} \rangle 
				 }}{ 
				 \vmat{ 1 & \dots & 1 \\ 
				 \langle \Delta x_n, \Delta x_n \rangle & \dots & \langle \Delta x_n, \Delta x_{n+k} \rangle \\ 
				 \vdots & & \vdots \\ 
				 \langle \Delta x_{n+k-1}, \Delta x_n \rangle & \dots & \langle \Delta x_{n+k-1}, \Delta x_{n+k} \rangle} 
				 }
\end{equation}

Suppose the sequence $(x_n)$ is defined as $x_{n+1} = A x_n + b$ for some matrix $A$ and vector $b$.
The residual $r(x) = Ax + b - x$ satisfies $r(x_i) = \Delta x_i$ and $r(s)=0$ where $s$ is the limit of the sequence, $s=As+b$.
Moreover,
\begin{equation}
\Delta x_{i+1} = A x_i + b - x_i = A x_i + b - A x_{i-1} - b = A \Delta x_i = A^{i+1} \Delta x_0.
\end{equation}
Thus, 
\begin{equation}
r(T_n^{(k)}) = \sum \gamma_i^{(n,k)} \Delta x_{n+i} \in \Span \set{\Delta x_n, A \Delta x_n, \dots , A^k \Delta x_n} = K_{k-1}(A,\Delta x_n)
\end{equation}
where $K_{k+1}(A,\Delta x_n)$ is the Krylov subspace of dimension $k+1$ generated by $A$ and $\Delta x_n$.
By Equation (\ref{eq:gamma 2}) we have that $\langle v, r(T_n^{(k)}) \rangle = 0$ for all $v \in K_{k}(A,\Delta x_n)$.
Therefore, MPE is an orthogonal projection method.
In fact, it is identical in methodology to the Arnoldi process.

\section{MPE as a quasi-Newton method}

\subsection{Quasi-Newton methods}

\newcommand{\fxi}[1]{\vec{f}(\vec{x}_{#1})}
\newcommand{\Jxn}{J(\vec{x}_n)}

A quasi-Newton method is any method of the form
\begin{equation} \label{eq:quasiNewton}
\hat{\vec{x}}_{n+1} = \vec{x}_n - \vec{u}_n
\end{equation}
where $\vec{u}_n$ is an approximate solution to the equation
\begin{equation} \label{eq:Newtondirection}
J(\vec{x}_n)  \vec{u} = \vec{f}(\vec{x}_n)
\end{equation}
where $J(\vec{x})$ is the Jacobain of $\vec{f}(\vec{x})$ evaluated at $\vec{x}_n$.

One can expand the function $\vec{f}(\vec{x})$ into a Taylor series about $\vec{x}_n$:
\begin{equation*}
\fxi{n+i} = \vec{f}(\vec{x}_n) + J(\vec{x}_n) ( \vec{x}_{n+i} - \vec{x}_n ) + \frac{1}{2} ( \vec{x}_{n+i} - \vec{x}_n ) H(\vec{x}_n) ( \vec{x}_{n+i} - \vec{x}_n ) + \dots
\end{equation*}
As a first order approximation we can take the first two terms of this series, resulting in the following approximate equation:
\begin{equation*}
\fxi{n+i} - \fxi{n} \approx \Jxn ( \vec{x}_{n+i} - \vec{x}_n ).
\end{equation*}
Such a system can be solved for $\Jxn$ though such a system would be underdetermined.
However, if one had as many $\fxi{n+i}$ as there are dimensions in the space then one could solve
\begin{equation}
\begin{bmatrix} \fxi{n+1} & \dots & \fxi{n+d} \end{bmatrix} - \fxi{n} = \hat{J} \left ( \begin{bmatrix}
\vec{x}_{n+1} & \dots & \vec{x}_{n+d} \end{bmatrix} - \vec{x}_n \right )
\end{equation}
which is nonsingular given sufficient conditions on the choice of $\vec{x}_{n+i}$.

Let $X = \begin{bmatrix} \vec{x}_{n+1} & \dots & \vec{x}_{n+d} \end{bmatrix} - \vec{x}_n$ and $F = \begin{bmatrix} \fxi{n+1} & \dots & \fxi{n+d} \end{bmatrix} - \fxi{n}$, then
$$\hat{J}^{-1} = X F^{-1}.$$
Combining this with equations (\ref{eq:quasiNewton}) and (\ref{eq:Newtondirection}) gives the quasi-Newton method
\begin{equation}
\hat{\vec{x}}_{n+1} = \vec{x}_n - X F^{-1} \fxi{n}.
\end{equation}

The vector $F^{-1} \fxi{n}$ may be found elementwise by Cramer's rule:
\begin{align*}
\left (F^{-1} \fxi{n} \right)_i = & \frac{ \vmat{
\fxi{n+1} - \fxi{n} & \dots & \fxi{n+i-1} - \fxi{n} & \fxi{n} & \fxi{n+i+1}-\fxi{n} & \dots & \fxi{n+d}-\fxi{n}
}
}{ \vmat{
\fxi{n+1}-\fxi{n} & \dots & \fxi{n+d}-\fxi{n}
}
} \\
= & (-1)^i \frac{ \vmat{
\fxi{n} & \dots & \fxi{n+i-1} & \fxi{n+i+1} & \fxi{n+d}
}
}{ \vmat{
1 & \dots & 1 \\ \fxi{n} & \dots & \fxi{n+d}
}}.
\end{align*}
The quasi-Newton method defined above may then be expressed as
\begin{align*}
\hat{\vec{x}}_{n+1} = & \vec{x}_n - \frac{\vmat{
0 & \vec{x}_{n+1} - \vec{x}_n & \dots & \vec{x}_{n+d} - \vec{x}_n \\
\fxi{n} & \fxi{n+1} & \dots & \fxi{n+d} }
}{ \vmat{
1 & \dots & 1 \\ \fxi{n} & \dots & \fxi{n+d} }} \\
= & \frac{ \vmat{
\vec{x}_n & \dots & \vec{x}_{n+d} \\ \fxi{n} & \dots & \fxi{n+d} }
}{ \vmat{
1 & \dots & 1 \\ \fxi{n} & \dots & \fxi{n+d} }}
\end{align*}
where one must expand the determinant along the top row to maintain the correct dimensions.

Suppose, for whatever reason, that we do not have enough values of $\fxi{n+i}$ to fully determine $\hat{J}$.
That is, suppose $F$ and $X$ have $d$ rows but only $k$ columns, and denote these submatrices by $F_k$ and $X_k$.
Rather than solve $\hat{J} \vec{u}_n = \fxi{n}$ we can make a further approximation by solving $A^\top \hat{J} \vec{u}_n = A^\top \fxi{n}$ for some matrix $A$ with the same dimension as $F_k$.
This has as its solution $\vec{u}_n = X_k (A^\top F_k)^{-1} A^\top \fxi{n}$.
It is clear that the quasi-Newton method that results from this may be written as
\begin{equation} \label{eq:uqn}
\hat{\vec{x}}_{n+1} = \frac{ \vmat{
\vec{x}_n & \dots & \vec{x}_{n+k} \\
\vec{v}_1^\top \fxi{n} & \dots & \vec{v}_1^\top \fxi{n+k} \\
\vdots & & \vdots \\
\vec{v}_k^\top \fxi{n} & \dots & \vec{v}_k^\top \fxi{n+k} }}{ \vmat{
1 & \dots & 1 \\
\vec{v}_1^\top \fxi{n} & \dots & \vec{v}_1^\top \fxi{n+k} \\
\vdots & & \vdots \\
\vec{v}_k^\top \fxi{n} & \dots & \vec{v}_k^\top \fxi{n+k} }}
\end{equation}
where $\vec{v}_i$ is the $i$--th column of $A$.

\subsection{Connection to extrapolation methods}

Let $\vec{r}(\vec{x}_i) = \vec{x}_{i+1} - \vec{x}_i$ be the residual function.
Then MPE may be expressed as equation (\ref{eq:uqn}) with $\fxi{i} = \vec{r}(\vec{x}_i)$ and $\vec{v}_i = \vec{r}(\vec{x}_{n+i-1})$.
RRE and MMPE may also be expressed as such, using $\vec{v}_i = \vec{r}(\vec{x}_{n+i}) - \vec{r}(\vec{x}_{n+i-1})$ and $\vec{v}_i$ some fixed vector independent of $\vec{r}(\vec{x})$, respectively.

TEA also has a connection to quasi-Newton methods, though in a more roundabout way.
Recall the equation that forms the foundation of the quasi-Newton methods expressed in this section:
\begin{equation}
F_k = \hat{J} X_k.
\end{equation}
This equation assumes that our starting position is $\vec{x}_n$.
If our starting position is instead $\vec{x}_{n+j}$ then the equation becomes
\begin{equation}
F_{n+j,k} = \hat{J}_{n+j} X_{n+j,k}.
\end{equation}
We can create any number of these equations as long as we have enough values of $\fxi{n+j}$ and $\vec{x}_{n+j}$.

Using all of these equations to determine a direction would create an overdetermined system.
One way to reduce the size of such a system is to take the inner product with some vector $\vec{q}$:
\begin{equation*}
\vec{q}^\top F_{n+j,k} = \vec{q}^\top \hat{J}_{n+j} X_{n+j,k}.
\end{equation*}
This forms one row of a larger linear equation.

Recall that we sought $\vec{u}_j$ such that $F_{n+j,k} \vec{u}_j = \fxi{n+j}$, which led to the Newton step $\vec{x}_{n+j} - X_{n+j,k} \vec{u}_j$.
If we assume that $\vec{u}_j = \vec{u}$ for all $j$ then we can write the quasi-Newton method as
\begin{align*}
\begin{bmatrix} \vec{q}^\top F_{n,k} \\ \vdots \\ \vec{q}^\top F_{n+k-1,k} \end{bmatrix} \vec{u} = & \begin{bmatrix} \vec{q}^\top \fxi{n} \\ \vdots \\ \vec{q}^\top \fxi{n+k-1} \end{bmatrix}, \\
\vec{\hat{x}}_{n+1} = & \vec{x}_n - X_{n,k} \vec{u}.
\end{align*}
This gives as its solution
\begin{equation}
\vec{\hat{x}}_{n+1} = \frac{ \vmat{
\vec{x}_n & \dots & \vec{x}_{n+k} \\
\vec{q}^\top \fxi{n} & \dots & \vec{q}^\top \fxi{n+k} \\
\vdots & & \vdots \\
\vec{q}^\top \fxi{n+k-1} & \dots & \vec{q}^\top \fxi{n+2k-1}
}}{ \vmat{
1 & \dots & 1 \\
\vec{q}^\top \fxi{n} & \dots & \vec{q}^\top \fxi{n+k} \\
\vdots & & \vdots \\
\vec{q}^\top \fxi{n+k-1} & \dots & \vec{q}^\top \fxi{n+2k-1}}}
\end{equation}
which is exactly TEA when replacing $\fxi{n+j}$ with $\vec{x}_{n+j+1} - \vec{x}_{n+j} = \vec{r}(\vec{x}_{n+j})$.

\section{Generalized Shanks Transformation}

Suppose that we have a sequence $\set{x_n}$ that tends towards $s$ as
$$ x_n \tilde s + \sum_{i=1}^\infty a_i \lambda_i^n. $$
Then we say $s_{n,k}$ is an approximation of $s$ such that
\begin{equation}
x_{n+j} = s_{n,k} + \sum_{i=1}^k a_i \lambda_i^{n+j}
\end{equation}
for all $0 \leq j \leq 2k$.
This gives $2k+1$ equations to solve for the $2k+1$ unknowns ($s_{n,k}$, $a_i$ and $\lambda_i$).

We know that the final result will be a sum of $x_{n+j}$.
Suppose the solution is
\begin{align*}
s_{n,k} = & \sum_{j=0}^m \gamma_j x_{n+j} \\
		= & \sum_{j=0}^m \gamma_j \left ( s_{n,k} + \sum_{i=0}^k a_i \lambda_i^{n+j} \right ) \\
		= & \left ( \sum_{j=0}^m \gamma_j \right ) s_{n,k} + \sum_{j=0}^m \sum_{i=0}^k a_i \lambda_i^{n+j}.
\end{align*}
Naturally this means $\sum_{j=0}^m \gamma_j = 1$.

Suppose also that
\begin{equation*}
s_{n,k} = \sum_{j=0}^m \gamma_j x_{n+j+i}
\end{equation*}
for $0 \leq i \leq 2k-m-1$.
Then
\begin{align*}
s_{n,k} - s_{n,k} = & \sum_{j=0}^m \gamma_j \left ( x_{n+j+i+1} - x_{n+j+i} \right ) \\
0 = & \sum_{j=0}^m \gamma_j r_{n+j+i}
\end{align*}
for the same set of $i$.
This gives the following linear equation:
\begin{equation*}
\begin{bmatrix} 1 & \dots & 1 \\ r_n & \dots & r_{n+m} \\ \vdots & & \vdots \\ r_{n+2k-m-1} & \dots & r_{n+2k-1} \end{bmatrix} \begin{bmatrix} \gamma_0 \\ \vdots \\ \gamma_m \end{bmatrix} = \begin{bmatrix} 1 \\ 0 \\ \vdots \\ 0 \end{bmatrix}.
\end{equation*}
For this equation to be solvable one requires that $2k-m = m$, or $m=k$.
The solution is then
\begin{align*}
\gamma_i = & \frac{\vmat{
1 & \dots & 1 & 1 & 1 & \dots & 1 \\
r_n & \dots & r_{n+i-1} & 0 & r_{n+i+1} & \dots & r_{n+k} \\
\vdots & & \vdots & \vdots & \vdots & & \vdots \\
r_{n+k-1} & \dots & r_{n+i+k-2} & 0 & r_{n+i+k} & \dots & r_{n+2k-1}
}}{\vmat{
1 & \dots & 1 \\ r_n & \dots & r_{n+k} \\ \vdots & & \vdots \\ r_{n+k-1} & \dots & r_{n+2k-1} }} \\
= & \frac{\vmat{
r_n & \dots & r_{n+i-1} & r_{n+i+1} & \dots & r_{n+k} \\
\vdots & \vdots & \vdots & \vdots & & \vdots \\
r_{n+k-1} & \dots & r_{n+i+k-2} & r_{n+i+k} & \dots & r_{n+2k-1}
}}{\vmat{
1 & \dots & 1 \\ r_n & \dots & r_{n+k} \\ \vdots & & \vdots \\ r_{n+k-1} & \dots & r_{n+2k-1} }}
\end{align*}
which gives
\begin{equation}
s_{n,k} = \frac{\vmat{
x_n & \dots & x_{n+k} \\ r_n & \dots & r_{n+k} \\ \vdots & & \vdots \\ r_{n+k-1} & \dots & r_{n+2k-1} }}{\vmat{
1 & \dots & 1 \\ r_n & \dots & r_{n+k} \\ \vdots & & \vdots \\ r_{n+k-1} & \dots & r_{n+2k-1} }}.
\end{equation}

\section{Equivalence of many quasi-Newton methods}

Suppose we have a method such that
\begin{equation}
\begin{bmatrix} 1 & \dots & 1 \\ \fxi{n} & \dots & \fxi{n+k} \end{bmatrix} \vec{u} = \begin{bmatrix} \vec{1}^\top \\ F_{n,k} \end{bmatrix} \vec{u} = \begin{bmatrix} 1 \\ 0 \end{bmatrix}, \\ \hat{\vec{x}} = \begin{bmatrix} \vec{x}_n & \dots & \vec{x}_{n+k} \end{bmatrix} \vec{u} = X_{n,k} \vec{u}
\end{equation}
then one can write an equivalent method:
\begin{equation*}
\hat{\vec{x}} = X_{n,k} \vec{u} = \vec{x}_{n+i} - X_{n,k} (\vec{e}_i - \vec{u}) = \vec{x}_{n+i} - X_{n,k} \hat{\vec{u}}
\end{equation*}
where $\hat{\vec{u}}$ satisfies
\begin{equation*}
\begin{bmatrix} \vec{1}^\top \\ F_{n,k} \end{bmatrix} \hat{\vec{u}} = \begin{bmatrix} 0 \\ \fxi{n+i} \end{bmatrix}.
\end{equation*}
Replace $\hat{\vec{u}}$ with $\Delta \tilde{\vec{u}}$ where $\Delta$ is some matrix representing a differentiation operator.
The conditions on $\Delta$ are that it has $k+1$ rows and $k$ columns, and its columns sum to zero.
Then an equivalent method is
\begin{equation*}
\hat{\vec{x}} = \vec{x}_{n+i} - X_{n,k} \Delta \tilde{\vec{u}}
\end{equation*}
where
\begin{equation*}
\begin{bmatrix} \vec{1}^\top \\ F_{n,k} \end{bmatrix} \Delta \tilde{\vec{u}} = \begin{bmatrix} 0 \\ \fxi{n+i} \end{bmatrix} \implies F_{n,k} \Delta \tilde{\vec{u}} = \fxi{n+i}.
\end{equation*}
Some standard choices of $\Delta$:
\begin{equation*}
\begin{bmatrix} -1 & \dots & -1 \\ 1 \\ & \ddots \\ & & 1 \end{bmatrix}, \quad \begin{bmatrix} -1 \\ 1 & \ddots \\ & \ddots & -1 \\ & & 1 \end{bmatrix}.
\end{equation*}

The equations to solve for $\vec{u}$, $\hat{\vec{u}}$ and $\tilde{\vec{u}}$ are solved in some sense.
For example, if $\vec{f} : \bbr^d \to \bbr^d$ and $k< d$ then each of the presented systems is underdetermined.
If $k>d$ then they are overdetermined.
To solve the system(s) one can multiply by a matrix $A^\top$:
\begin{equation*}
\begin{bmatrix} \vec{1}^\top \\ A^\top F_{n,k} \end{bmatrix} \vec{u} = \begin{bmatrix} 1 \\ 0 \end{bmatrix}, \quad A^\top F_{n,k} \Delta \tilde{\vec{u}} = A^\top \fxi{n+i} .
\end{equation*}

Note that $\hat{\vec{x}}$ is always in the span of $\set{\vec{x}_{n+i}}_{i=0}^k$.
Therefore, if $k<d$ then $\hat{\vec{x}}$ is in a restricted subspace of $\bbr^d$.

\section{Multisecant equations}

The multisecant equations presented previously may be summarized as
\begin{equation}
F_{n,k} \Delta = \hat{J} X_{n,k} \Delta
\end{equation}
where all components have been previously defined.
The square matrix $\hat{J}$ is an approximation of the Jacobian for the vector-valued function $\fxi{}$ for somewhere in the simplex of the columns of $X_{n,k}$.
Generally, it can be thought of as an approximation of $J(\vec{x}_n)$ or $J(\vec{x}_{n+k})$ but could also represent $J(\vec{x}_{n+i})$ for any $i$ between 0 and $k$, due to the equivalence of these equations explained previously.

These equations appear in many, if not all, quasi-Newton methods.
The update for Broyden's method is chosen such that
\begin{equation*}
\hat{J}_{n+1} \begin{bmatrix} X_{n,1} \Delta & Q \end{bmatrix} = \begin{bmatrix} F_{n,1} \Delta & \hat{J}_n Q \end{bmatrix}
\end{equation*}
where $Q^\top X_{n,1} \Delta = 0$.
In the generalized Broyden's method $X_{n,1}$ and $F_{n,1}$ are replaced by $X_{n,k}$ and $F_{n,k}$ and $Q$ reduced in size by $k$ columns.

Broyden's family of methods may be written as
\begin{equation*}
\hat{J}_{n+1} = \hat{J}_n + \fxi{n+1} \vec{v}_n^\top
\end{equation*}
where $\vec{v}_n^\top (\vec{x}_{n+1} - \vec{x}_n) = 1$.
If $\vec{v}_n$ is chosen such that
\begin{equation*}
\vec{v}_n^\top X_{n-k,k} \Delta = \begin{bmatrix} 0 & \dots & 0 & 1 \end{bmatrix}
\end{equation*}
with possibly other constraints then $\hat{J}_{n+1} X_{n-k,k} \Delta = F_{n-k,k} \Delta$.

Anderson mixing solves $F_{n,k} \Delta \vec{u} = \fxi{n+k}$ in a least-squares sense then uses the step
\begin{equation*}
\hat{\vec{x}}_{n+k+1} = \vec{x}_{n+k} - X_{n,k} \Delta \vec{u} + \beta \left ( \fxi{n+k} - F_{n,k} \Delta \vec{u} \right ).
\end{equation*}
For $\beta=0$ this is exactly the multisecant equations.

\section{Connection to Krylov methods}

Recall that the extrapolation methods may be expressed as
\begin{equation*}
\begin{bmatrix} 1^\top \\ B^\top F_{n,k} \end{bmatrix} \vec{u} = \begin{bmatrix} 1 \\ 0 \end{bmatrix}, \quad \hat{\vec{x}} = X_{n,k} \vec{u}
\end{equation*}
where $B = F_{n,k-1}$ for MPE, $B = F_{n+1,k} - F_{n,k-1} = F_{n,k} \Delta$ for RRE, and $B = \begin{bmatrix} \vec{q}_1 & \dots & \vec{q}_k \end{bmatrix}$ for MMPE.
TEA cannot be expressed in this form in general.

If the columns of $F_{n,k}$ form a Krylov subspace, that is $\fxi{n+1} = A \fxi{n}$ for all $n$, then these methods are Krylov methods.
For example, MPE now requires that $F_{n,k} \vec{u}$ is orthogonal to all $\fxi{n+i}$ for $i < k$.
Therefore, the residual $F_{n,k} \vec{u}$ is orthogonal to the Krylov subspace $\mathcal{K}_{k-1}(A,\fxi{n})$.
This is equivalent then to GMRES (see Sidi and Walter \& Ni for details).

TEA may now be expressed as the form above with $B = \begin{bmatrix} \vec{q} & A^\top \vec{q} & \dots & (A^\top)^{k-1} \vec{q} \end{bmatrix}$.
Table \ref{tab:KrylovExtrap} gives the orthogonalization conditions and corresponding Krylov methods for these four extrapolation methods.

\begin{table}
	\begin{tabular}{c | c | c}
		Extrapolation method & Residual is orthogonal to... & Associated Krylov method \\ \hline
		MPE & $\mathcal{K}_{k-1} (A,\fxi{n})$ (Arnoldi) & GMRES \\
		RRE & $\mathcal{K}_{k-1} (A-I,\fxi{n})$ & generalized conjugate residual \\
		MMPE & $\mathcal{K}_{k-1} (G,\vec{q}_0)$ & n/a \\
		TEA & $\mathcal{K}_{k-1} (A^\top, \vec{q})$ (Lanczos) & BiCG
	\end{tabular}
	\caption{Connections between extrapolation methods and Krylov methods.}
	\label{tab:KrylovExtrap}
\end{table}

The methods become Krylov methods most readily when the sequence to be accelerated may be expressed as $\vec{x}_{n+1} = A \vec{x}_n + \vec{b}$.
Under this sequence the function $\fxi{n}=\vec{x}_{n+1}-\vec{x}_n$ satisfies
\begin{align*}
\fxi{n}= & \vec{x}_{n+1} - \vec{x}_n \\
	= & A \vec{x}_n + \vec{b} - \vec{x}_n \\
	= & (A-I) \vec{x}_n + \vec{b}, \\
\fxi{n+1} = & \vec{x}_{n+2} - \vec{x}_{n+1} \\
	= & A \vec{x}_{n+1} + \vec{b} - A \vec{x}_n - \vec{b} \\
	= & A (\vec{x}_{n+1} - \vec{x}_n) \\
	= & A \fxi{n}.
\end{align*}

Suppose we wish to solve $(A-I) \vec{x} = -\vec{b}$.
It is then the goal to minimize $\norm{(A-I) \hat{\vec{x}} + \vec{b}}$.
We consider three types of solutions:
\begin{enumerate}
\item $\hat{\vec{x}} = X_{n,k} \vec{u}_k$ such that $\vec{1}^\top \vec{u}_k=1$;
\begin{align*}
\norm{(A-I) X_{n,k} \vec{u}_k + \vec{b}} = & \norm{((A-I) X_{n,k} + \vec{b} \vec{1}^\top) \vec{u}_k} \\
						     = & \norm{F_{n,k} \vec{u}_k}.
\end{align*}

\item $\hat{\vec{x}} = \vec{x}_n + X_{n,k} \Delta \tilde{\vec{u}}_k$ where
\begin{equation*}
\Delta = \begin{bmatrix} -1 \\ 1 & \ddots \\ & \ddots & -1 \\ & & 1 \end{bmatrix};
\end{equation*}
\begin{align*}
\norm{(A-I) \vec{x}_n + (A-I) X_{n,k} \Delta \tilde{\vec{u}}_k + \vec{b}} = & \norm{\fxi{n} + F_{n,k} \Delta \tilde{\vec{u}}_k} \\
											 = & \norm{\fxi{n} + (A-I) F_{n,k-1} \tilde{\vec{u}}_k}.
\end{align*}

\item $\hat{\vec{x}} =\vec{x}_n + Q_k \vec{y}_k$ where $Q_k$ is derived from the Arnoldi iteration on the Krylov subspace $\mathcal{K}_{k-1}(A-I,\fxi{n})$;
\begin{align*}
\norm{(A-I) \vec{x}_n + (A-I) Q_k \vec{y}_k + \vec{b}} = & \norm{\fxi{n} + (A-I) Q_k \vec{y}_k}.
\end{align*}
\end{enumerate}
Method 1 is equivalent to MPE since minimizing this equation is equivalent to solving the normal equations.
We have previously shown that methods 1 and 2 are equivalent.
Method 3 is GMRES, and to show it is equivalent to method 2 it suffices to prove the Krylov subspace $\mathcal{K}_{k-1}(A-I,\fxi{n})$ is the same as the column space of $F_{n,k-1}$.
This is trivial to show.

If $Q_k$ is derived from another method but shares the column space of $F_{n,k-1}$ then there is still mathematical equivalence between methods 2 and 3.
If one minimizes with respect to a different norm then the methods correspond to other methods discussed here.

\begin{figure}
  \centering
  \begin{tikzpicture}
    \matrix (m) [column sep=0.8cm, row sep=1em]{
      & & & & \node[align=center] (Anderson) {Anderson\\mixing}; \\
      \node[align=center] (multisecant) {$\begin{bmatrix} \vec{1}^\top \\ F_{n,k} \end{bmatrix} \vec{u} = \begin{bmatrix} 1 \\ 0 \end{bmatrix}$,\\ $X_{n,k} \vec{u} = \hat{\vec{x}}$}; &
      \node (overdetermined) {$\begin{bmatrix} \vec{1}^\top \\ B^\top F_{n,k} \end{bmatrix} \vec{u} = \begin{bmatrix} 1 \\ 0 \end{bmatrix}$}; & &
      \node (preMPE) {}; & \node (MPE) {MPE}; \\
      & & & & \node (GMRES) {GMRES}; \\
      \node[align=center] (preBroyden) {$\begin{bmatrix} \vec{1}^\top & \vec{1}^\top \\ F_{n,k} & B \end{bmatrix} \vec{u} = \begin{bmatrix} 1 \\ 0 \end{bmatrix}$,\\ $\begin{bmatrix} X_{n,k} & C \end{bmatrix} \vec{u} = \hat{\vec{x}}$};
      & \node (prepreRRE) {}; & & \node (preRRE) {}; & \node (RRE) {RRE}; \\
      & & & & \node (GCR) {GCR}; \\
      & \node (prepreMMPE) {}; & & \node (preMMPE) {}; & \node (MMPE) {MMPE}; \\
      & \node (preTEA) {}; & & \node (preBiCG) {}; & \node (BiCG) {BiCG}; \\
      \node (Broyden) {Generalized Broyden};
      & & & & \node (TEA) {TEA*}; \\
      };
    \path[->,very thick]
      (multisecant) edge node[above] {$k \neq d$} (overdetermined) edge node[right] {$k < d$} (preBroyden)
      (preBroyden) edge node[right,align=left] {$(C \Delta)^\top (X_{n,k} \Delta) = 0$, \\ $B = \hat{J}_{n-1,k} C$} (Broyden)
      (overdetermined) edge node[above] {$B=F_{n,k-1}$} (preMPE)
      (preMPE) edge[red] (MPE)
      (prepreRRE) edge node[above] {$B=F_{n,k} \Delta$} (preRRE)
      (preRRE) edge[red] (RRE)
      (prepreMMPE) edge node[above] {$B=\begin{bmatrix} \vec{q}_1 & \dots & \vec{q}_k \end{bmatrix}$} (preMMPE)
      (preMMPE) edge[red] (MMPE)
      (preTEA) edge node[above] {$B=\begin{bmatrix} \vec{q} & A^\top \vec{q} & \dots \end{bmatrix}$} (preBiCG)
      (preBiCG) edge[blue] (BiCG)
      (BiCG) edge[red] (TEA);
    \draw[-, very thick] (overdetermined) edge (preTEA);
    \draw[->,very thick,blue] (preMPE) |- (GMRES);
    \draw[->,very thick,blue] (preRRE) |- (GCR);
    \draw[->,very thick] (preMPE) |- node[above] {+relaxation} (Anderson);
  \end{tikzpicture}
  \caption{Interconnectivity of extrapolation, acceleration and quasi-Newton methods.
  Red arrows indicated $\fxi{n} = \vec{x}_{n+1}-\vec{x}_n$ while blue arrows indicate $\fxi{n} = (A-I) \vec{x}_n + \vec{b}$ and $\fxi{n+1} = A \fxi{n}$.
  Note that TEA* is the linear version of the method; general TEA derives directly from the multisecant equations.}
\end{figure}

\end{document}